package com.inca.npbusi.sales.bms_group_sa_doc;

import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.control.Hovcallback;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.saHelper.SaExamHelper;
import com.inca.npx.ste.ApIF;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.sastqtyhov.Sadynstqty_hov;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.JOptionPane;
import org.apache.log4j.Category;

public class Bms_sales_detail extends CDetailModel implements Hovcallback {
   private Category a = Category.getInstance(Bms_sales_detail.class);
   private String b = "";
   private String c = "";
   private String d = "";
   private String e = "";
   private HashMap<String, String> f = new HashMap();
   private Sadynstqty_hov g;
   private HashMap<String, String> h;
   private HashMap<String, ArrayList<String>> i;

   public Bms_sales_detail(CFrame var1, CMdeModel var2) {
      super(var1, "销售发货单细单", var2);
      this.g = new Sadynstqty_hov((ApIF)this.mdemodel);
      this.h = new HashMap();
      this.i = new HashMap();
      DBColumnDisplayInfo var3;
      (var3 = this.getDBColumnDisplayInfo("reqprintquflag")).addComboxBoxItem("0", "不需要");
      var3.addComboxBoxItem("1", "需要");
      (var3 = this.getDBColumnDisplayInfo("hasprintquflag")).addComboxBoxItem("0", "未打印");
      var3.addComboxBoxItem("1", "已打印");
   }

   public String getTablename() {
      return "bms_group_sa_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_beforeNew() {
      if (this.mdemodel.getMasterModel().getRow() >= 0 && this.mdemodel.getMasterModel().getRow() != this.mdemodel.getMasterModel().getRowCount()) {
         return "2".equals(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus")) && "0".equals(this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "approveflag")) ? super.on_beforeNew() : -1;
      } else {
         return -1;
      }
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3;
      if ((var3 = this.getItemValue(var1, "discount")) != null && !var3.equals("") && !var3.equals("0") && !var3.equals("0.00")) {
         if (DecimalHelper.toDec(var3).compareTo(new BigDecimal("0")) < 0) {
            this.infoMessage("提示", "折扣不能小于零");
            return -1;
         } else {
            var3 = this.getItemValue(var1, "goodsqty");
            if (!"".equals(var3) && DecimalHelper.toDec(var3).compareTo(new BigDecimal("0")) > 0) {
               String var4 = this.getItemValue(var1, "unitprice");
               if (!"".equals(var4) && DecimalHelper.toDec(var4).compareTo(new BigDecimal("0")) > 0) {
                  RemotesqlHelper var6;
                  String var11;
                  if ((var4 = this.getItemValue(var1, "posid")) != null && !var4.equals("") && !var4.equals("0")) {
                     DBTableModel var5 = null;
                     var6 = new RemotesqlHelper();
                     var4 = "select * from bms_storer_pos where posid = " + var4;

                     try {
                        var5 = var6.doSelect(var4, 0, 1);
                     } catch (Exception var9) {
                        var9.printStackTrace();
                     }

                     if (var5.getRowCount() <= 0) {
                        return -1;
                     }

                     var11 = var5.getItemValue(0, "goodsunitflag");
                     if ("1".equals(var11)) {
                        String var7 = this.getItemValue(var1, "packsize");
                        if (DecimalHelper.toDec(var3).remainder(DecimalHelper.toDec(var7)).compareTo(new BigDecimal("0")) != 0) {
                           this.infoMessage("提示", "整件货位的数量必须是整件！");
                           return -1;
                        }
                     }
                  }

                  String var10 = this.getItemValue(var1, "lotid");
                  var11 = this.getItemValue(var1, "storageid");
                  var4 = "select * from bms_st_def a where a.storageid=" + var11;
                  var6 = new RemotesqlHelper();
                  DBTableModel var12 = null;

                  try {
                     var12 = var6.doSelect(var4, 0, 1);
                  } catch (Exception var8) {
                     var8.printStackTrace();
                  }

                  if (var12 != null && var12.getRowCount() > 0 && (var3 = var12.getItemValue(0, "lotflag")) != null && var3.equals("1") && (var10 == null || var10.equals(""))) {
                     this.infoMessage("提示", "请选择到批号！否则销退勾原单的话没有批号无法确定");
                     return -1;
                  } else {
                     var3 = this.getItemValue(var1, "wholeresaleflag");
                     if ("9".equals(var3)) {
                        var3 = this.getItemValue(var1, "taxbatchprice");
                        if ("".equals(var3)) {
                           this.infoMessage("提示", "价格类别为批次价的，含税批次价不能为空！");
                           return -1;
                        }
                     }

                     return super.on_checkrow(var1, var2);
                  }
               } else {
                  this.infoMessage("提示", "要求单价必须大于零");
                  return -1;
               }
            } else {
               this.infoMessage("提示", "使用单位数量必须大于零");
               return -1;
            }
         }
      } else {
         this.infoMessage("提示", "折扣不能为空");
         return -1;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
      String var5;
      String var6;
      String var7;
      String var8;
      String var9;
      String var11;
      String var12;
      String[] var13;
      String var33;
      if (var2.equals("goodsid")) {
         this.commitEdit();
         super.on_itemvaluechange(var1, var2, var3);
         var5 = this.getItemValue(this.getRow(), "goodsunit");
         this.setItemValue(this.getRow(), "goodsuseunit", var5);
         if ((this.b != null && !"".equals(this.b) || this.d != null && !"".equals(this.d)) && !this.isLimitCustom(var1)) {
            return;
         }

         if (this.c != null && !"".equals(this.c) && !this.isLimitCustomSet(var1, this.c)) {
            return;
         }

         if (this.e != null && !"".equals(this.e) && !this.isLimitCustomSet(var1, this.e)) {
            return;
         }

         if (this.b(var1)) {
            var7 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            var8 = this.getItemValue(var1, "goodsid");
            var9 = this.getItemValue(var1, "batchid");
            DBTableModel var29 = null;
            ClientRequest var37 = new ClientRequest();
            StringCommand var34 = new StringCommand("根据取价逻辑自动提取价格信息");
            ParamCommand var36;
            (var36 = new ParamCommand()).addParam("customid", var7);
            var36.addParam("goodsid", var8);
            var36.addParam("entryid", ((Bms_sales_mde)this.mdemodel).getEntryid());
            ServerResponse var26;
            if (var9 != null && var9.length() != 0) {
               var36.addParam("batchid", var9);
               var37.addCommand(var34);
               var37.addCommand(var36);
               var26 = null;

               try {
                  var26 = SendHelper.sendRequest(var37);
               } catch (Exception var18) {
                  var18.printStackTrace();
               }

               if (((StringCommand)var26.commandAt(0)).getString().startsWith("+OK")) {
                  if (var26.commandAt(1) instanceof DataCommand) {
                     var29 = ((DataCommand)var26.commandAt(1)).getDbmodel();
                  } else if (var26.commandAt(1) instanceof StringCommand) {
                     var26.commandAt(1);
                  }
               }

               if (var29 != null && var29.getRowCount() > 0) {
                  var7 = var29.getItemValue(0, "price");
                  var8 = var29.getItemValue(0, "priceid");
                  this.setItemValue(var1, "priceid", var8);
                  this.setItemValue(var1, "priceopcode", var29.getItemValue(0, "priceopcode"));
                  this.setItemValue(var1, "pricename", var29.getItemValue(0, "pricename"));
                  var11 = null.getValue("wholesaleflag");
                  var9 = null.getValue("batchprice");
                  var8 = null.getValue("notaxsuprice");
                  if ("30".equals(var11)) {
                     this.getEditCompont("addrate").setEnabled(true);
                     var7 = var9;
                  } else {
                     this.getEditCompont("addrate").setEnabled(false);
                     this.setItemValue(var1, "addrate", "0");
                  }

                  this.setItemValue(var1, "wholesaleflag", var11);
                  this.setItemValue(var1, "batchprice", var8);
                  this.setItemValue(var1, "unitprice", var7);
                  this.setItemValue(var1, "timepriceid", var29.getItemValue(0, "refrencepriceid"));
                  this.setItemValue(var1, "timepricename", var29.getItemValue(0, "refrencepricename"));
                  this.setItemValue(var1, "timeprice", var29.getItemValue(0, "refrenceprice"));
                  this.on_itemvaluechange(var1, "unitprice", var7);
               }
            } else {
               this.infoMessage("提示", "请确定货品批次;");
            }

            var7 = this.getItemValue(var1, "goodsid");
            var8 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            ClientRequest var32 = new ClientRequest();
            StringCommand var35 = new StringCommand("Bms_sales_detail.取得上次销价类型信息");
            StringCommand var39 = new StringCommand(var7);
            var34 = new StringCommand(var8);
            var32.addCommand(var35);
            var32.addCommand(var39);
            var32.addCommand(var34);
            var33 = ((Bms_sales_mde)this.mdemodel).getEntryid();
            var32.addCommand(new StringCommand(var33));

            label238: {
               try {
                  var26 = SendHelper.sendRequest(var32);
               } catch (Exception var19) {
                  this.a.error("error", var19);
                  this.errorMessage("错误", var19.getMessage());
                  break label238;
               }

               if (((StringCommand)var26.commandAt(0)).getString().startsWith("+OK")) {
                  var33 = ((StringCommand)var26.commandAt(1)).getString();
                  var7 = ((StringCommand)var26.commandAt(2)).getString();
                  var8 = ((StringCommand)var26.commandAt(3)).getString();
                  var11 = ((StringCommand)var26.commandAt(4)).getString();
                  var9 = ((StringCommand)var26.commandAt(5)).getString();
                  this.setItemValue(var1, "lastpriceid", var33);
                  this.setItemValue(var1, "lastpricename", var7);
                  this.setItemValue(var1, "lastunitprice", var8);
                  this.setItemValue(var1, "lastdate", var11);
                  this.setItemValue(var1, "lastgoodsqty", var9);
               }
            }

            int var31 = var1;
            Bms_sales_detail var30 = this;
            ClientRequest var25 = new ClientRequest();
            var9 = null;
            var35 = new StringCommand("销售发货单管理:获取销售折扣");
            ParamCommand var41 = new ParamCommand();
            var12 = null;
            var13 = null;
            int var38 = this.mdemodel.getMasterModel().getRow();
            var12 = this.mdemodel.getMasterModel().getItemValue(var38, "customid");
            var33 = ((Bms_sales_mde)this.mdemodel).getEntryid();
            var41.addParam("goodsid", var3);
            var41.addParam("customid", var12);
            var41.addParam("entryid", var33);
            var25.addCommand(var35);
            var25.addCommand(var41);

            try {
               if (((StringCommand)(var26 = SendHelper.sendRequest(var25)).commandAt(0)).getString().startsWith("+OK")) {
                  var36 = (ParamCommand)var26.commandAt(1);
                  var30.setItemValue(var31, "discount", var36.getValue("discount"));
                  var30.setItemValue(var31, "olddiscount", var36.getValue("discount"));
               }
            } catch (Exception var17) {
               var17.printStackTrace();
            }

            var6 = "";
            DBTableModel var28 = null;
            var8 = "select salestaxrate from pub_goods_v where goodsid = " + var3;
            RemotesqlHelper var40 = new RemotesqlHelper();

            try {
               var28 = var40.doSelect(var8, 0, 1);
            } catch (Exception var16) {
               var16.printStackTrace();
            }

            if (var28 != null && var28.getRowCount() > 0) {
               var6 = var28.getItemValue(0, "salestaxrate");
            }

            this.setItemValue(var1, "taxrate", var6);
            var5 = DecimalHelper.divide(this.getItemValue(var1, "taxbatchprice"), DecimalHelper.add(var6, "1", 10), 10);
            this.setItemValue(var1, "batchprice", var5);
            this.on_itemvaluechange(var1, "goodsuseqty", this.getItemValue(var1, "goodsuseqty"));
            if ((var11 = ((Bms_sales_mde)this.mdemodel).nosapriceinfo) != null && var11.equals("1") && !this.a(var3)) {
               this.infoMessage("友情提示", "ID为" + var3 + "的货品尚未定义零售价，请及时维护!~");
            }

            if (var6 != null) {
               "".equals(var6);
            }

            this.setItemValue(var1, "batchprice", var5);
         }

         this.setItemValue(var1, "oldunitprice", this.getItemValue(var1, "unitprice"));
         this.on_itemvaluechange(var1, "oldunitprice", this.getItemValue(var1, "unitprice"));

         try {
            var6 = this.getItemValue(var1, "unitprice");
            var7 = this.getItemValue(var1, "goodsqty");
            String[] var27 = SaExamHelper.genExamInfo(var3, var6, var7, true, var1, "", var4);
            this.setItemValue(var1, "examprice", var27[0]);
            this.setItemValue(var1, "examprofit", var27[1]);
         } catch (Exception var15) {
            var15.printStackTrace();
         }
      } else {
         String[] var21;
         String[] var24;
         if (var2.equals("oldunitprice")) {
            this.setItemValue(var1, "discount", this.getItemValue(var1, "olddiscount"));
            var5 = this.getItemValue(var1, "discount");
            var6 = DecimalHelper.multi(var3, var5, 10);
            this.setItemValue(var1, "unitprice", var6);
            var7 = this.getItemValue(var1, "goodsqty");
            var8 = this.getItemValue(var1, "goodsid");
            var9 = this.getItemValue(var1, "examprice");
            var24 = SaExamHelper.genExamInfo(var8, var6, var7, false, var1, var9, "");
            this.setItemValue(var1, "examprice", var24[0]);
            this.setItemValue(var1, "examprofit", var24[1]);
            this.a(var1);
            var5 = this.getItemValue(var1, "batchid");
            if (var7 == null || var7.length() == 0) {
               var7 = "0";
            }

            var11 = this.getItemValue(var1, "total_line");
            if (!"".equals(var11) && !DecimalHelper.sub("0", var11, 0).equals("0")) {
               var21 = getLotGross(var8, var5, var3, var7, var11);
               this.setItemValue(var1, "lotgross", var21[0]);
               this.setItemValue(var1, "lotgrossrate", var21[1]);
            }

            this.setItemValue(var1, "addrate", "0");
         } else {
            String var10;
            String[] var23;
            if (var2.equals("unitprice")) {
               var6 = this.getItemValue(var1, "goodsid");
               this.a(var1);
               if ((var7 = this.getItemValue(var1, "oldunitprice")).equals("") || var7 == null) {
                  var7 = var3;
               }

               if (DecimalHelper.toDec(var7).compareTo(DecimalHelper.toDec("0")) != 0) {
                  var8 = DecimalHelper.divide(var3, var7, 4);
                  this.setItemValue(var1, "discount", var8);
               }

               var8 = this.getItemValue(var1, "batchid");
               if ((var9 = this.getItemValue(var1, "goodsqty")) == null || var9.length() == 0) {
                  var9 = "0";
               }

               var10 = this.getItemValue(var1, "total_line");
               var23 = getLotGross(var6, var8, var3, var9, var10);
               this.setItemValue(var1, "lotgross", var23[0]);
               this.setItemValue(var1, "lotgrossrate", var23[1]);
               var11 = this.getItemValue(var1, "examprice");
               var21 = SaExamHelper.genExamInfo(var6, var3, var9, false, var1, var11, var4);
               this.setItemValue(var1, "examprice", var21[0]);
               this.setItemValue(var1, "examprofit", var21[1]);
               if (!(var12 = this.getItemValue(var1, "packsize")).equals("") && var12 != null) {
                  this.setItemValue(var1, "packqty", DecimalHelper.divide(var9, var12, 6));
               } else {
                  this.setItemValue(var1, "packqty", "0");
               }

               if (this.getItemValue(var1, "wholesaleflag").equals("9") && (var10 = this.getItemValue(var1, "batchprice")) != null && var10.length() > 0 && DecimalHelper.toDec(var10).compareTo(new BigDecimal("0")) > 0) {
                  var11 = this.getItemValue(var1, "taxrate");
                  var5 = DecimalHelper.sub(DecimalHelper.divide(DecimalHelper.divide(var3, DecimalHelper.add("1", var11, 2), 10), var10, 2), "1", 2);
                  this.setItemValue(var1, "addrate", var5);
               }
            } else if ("wholesaleflag".equals(var2) && var3.trim().length() > 0) {
               if (var3.equals("9")) {
                  var5 = this.getItemValue(var1, "taxbatchprice");
                  var6 = this.getItemValue(var1, "taxrate");
                  if ((var7 = DecimalHelper.divide(var5, DecimalHelper.add(var6, "1", 10), 10)) == null || var7.trim().length() == 0) {
                     this.infoMessage("提示", "批次价为空，请检查;");
                     return;
                  }

                  this.getEditCompont("addrate").setEnabled(true);
                  this.on_itemvaluechange(var1, "addrate", "0");
               } else {
                  this.getEditCompont("addrate").setEnabled(false);
               }
            } else if ("addrate".equals(var2) && !"".equals(var3)) {
               if ((var5 = this.getItemValue(var1, "batchprice")) != null && var5.length() > 0 && DecimalHelper.toDec(var5).compareTo(new BigDecimal("0")) > 0) {
                  var6 = this.getItemValue(var1, "taxrate");
                  var7 = DecimalHelper.add("1", var6, 2);
                  var8 = DecimalHelper.add("1", var3, 2);
                  var9 = DecimalHelper.multi(DecimalHelper.multi(var5, var8, 10), var7, 10);
                  this.setItemValue(var1, "unitprice", var9);
                  this.a(var1);
                  if ((var5 = this.getItemValue(var1, "oldunitprice")).equals("") || var5 == null) {
                     var5 = var3;
                  }

                  if (DecimalHelper.toDec(var5).compareTo(DecimalHelper.toDec("0")) != 0) {
                     var11 = DecimalHelper.divide(var3, var5, 4);
                     this.setItemValue(var1, "discount", var11);
                  }

                  var11 = this.getItemValue(var1, "batchid");
                  var6 = this.getItemValue(var1, "goodsid");
                  if ((var12 = this.getItemValue(var1, "goodsqty")) == null || var12.length() == 0) {
                     var12 = "0";
                  }

                  var33 = this.getItemValue(var1, "total_line");
                  var24 = getLotGross(var6, var11, var9, var12, var33);
                  this.setItemValue(var1, "lotgross", var24[0]);
                  this.setItemValue(var1, "lotgrossrate", var24[1]);
                  var11 = this.getItemValue(var1, "examprice");
                  var23 = SaExamHelper.genExamInfo(var6, var3, var12, false, var1, var11, var4);
                  this.setItemValue(var1, "examprice", var23[0]);
                  this.setItemValue(var1, "examprofit", var23[1]);
               }
            } else if ("goodsuseqty".equals(var2) && !"".equals(var3)) {
               if ((var5 = this.getItemValue(var1, "goodsuseunit")).indexOf("(") == -1) {
                  var6 = "1";
               } else {
                  var6 = var5.substring(var5.indexOf("(") + 1, var5.indexOf(")"));
               }

               var7 = DecimalHelper.multi(var3, var6, 6);
               this.setItemValue(var1, "goodsqty", var7);
               var8 = this.getItemValue(var1, "goodsid");
               var9 = this.getItemValue(var1, "goodsname");
               int var22 = this.mdemodel.getMasterModel().getRow();
               var5 = this.mdemodel.getMasterModel().getItemValue(var22, "customid");
               var11 = this.getItemValue(var1, "salesdtlid");
               var6 = "0";
               if (var11 != null && var11.trim().length() > 0) {
                  var6 = b(var11);
               }

               var33 = this.getItemValue(var1, "limitedsaleflag");
               var10 = null;

               try {
                  if ("1".equals(var33) && DecimalHelper.toDec(var7).compareTo(DecimalHelper.toDec(var6)) > 0) {
                     var11 = DecimalHelper.sub(var7, var6, 6);
                     if (DecimalHelper.toDec(var10 = NpbusiDBHelper.getAllotqtyinfo(var8, var5).getItemValue(0, "allotqty")).compareTo(DecimalHelper.toDec(var11)) < 0) {
                        this.infoMessage("提示", "货品" + var9 + "为配额销售货品，当前可用配额为" + var10 + "，\n销售数量不得大于可用配额，请检查!");
                        return;
                     }
                  }
               } catch (Exception var14) {
                  var14.printStackTrace();
                  this.infoMessage("提示", "查询货品配额销售信息时出错:" + var14.getMessage());
               }

               if ((var11 = this.getItemValue(var1, "leastsaleqty")) != null && var11.trim().length() > 0 && !"0".equals(var11) && DecimalHelper.toDec(var7).remainder(DecimalHelper.toDec(var11)).compareTo(new BigDecimal("0")) != 0) {
                  var5 = DecimalHelper.divide(var7, var11, 0);
                  if ("0".equals(var5)) {
                     var5 = "1";
                  }

                  this.infoMessage("提示", "根据公司管理规定，您输入的数量【" + var7 + "】不是该货品最小销售数量【" + var11 + "】的整数倍，您可以录入【" + DecimalHelper.multi(var11, var5, 6) + "】或者【" + DecimalHelper.multi(var11, DecimalHelper.add(var5, "1", 6), 6) + "】进行销售。");
               }

               if (!(var5 = this.getItemValue(var1, "packsize")).equals("") && var5 != null) {
                  this.setItemValue(var1, "packqty", DecimalHelper.divide(var7, var5, 6));
               } else {
                  this.setItemValue(var1, "packqty", "0");
               }

               var5 = this.getItemValue(var1, "batchid");
               if ((var6 = this.getItemValue(var1, "unitprice")) == null || var6.length() == 0) {
                  var6 = "0";
               }

               this.a(var1);
               var9 = this.getItemValue(var1, "examprice");
               String[] var20 = SaExamHelper.genExamInfo(var8, var6, var7, false, var1, var9, var4);
               this.setItemValue(var1, "examprice", var20[0]);
               this.setItemValue(var1, "examprofit", var20[1]);
               var4 = this.getItemValue(var1, "total_line");
               var20 = getLotGross(var8, var5, var6, var7, var4);
               this.setItemValue(var1, "lotgross", var20[0]);
               this.setItemValue(var1, "lotgrossrate", var20[1]);
            } else if ("goodsuseunit".equals(var2) && !"".equals(var3)) {
               var5 = this.getItemValue(var1, "goodsuseqty");
               if (var3.indexOf("(") == -1) {
                  var6 = "1";
               } else {
                  var6 = var3.substring(var3.indexOf("(") + 1, var3.indexOf(")"));
               }

               var7 = DecimalHelper.multi(var5, var6, 6);
               this.setItemValue(var1, "goodsqty", var7);
               if (!(var8 = this.getItemValue(var1, "packsize")).equals("") && var8 != null) {
                  this.setItemValue(var1, "packqty", DecimalHelper.divide(var7, var8, 6));
               } else {
                  this.setItemValue(var1, "packqty", "0");
               }

               var9 = this.getItemValue(var1, "batchid");
               var10 = this.getItemValue(var1, "goodsid");
               if ((var5 = this.getItemValue(var1, "unitprice")) == null || var5.length() == 0) {
                  var5 = "0";
               }

               this.setFocus("goodsuseqty");
               this.a(var1);
               var11 = this.getItemValue(var1, "total_line");
               var21 = getLotGross(var10, var9, var5, var7, var11);
               this.setItemValue(var1, "lotgross", var21[0]);
               this.setItemValue(var1, "lotgrossrate", var21[1]);
               var12 = this.getItemValue(var1, "examprice");
               var13 = SaExamHelper.genExamInfo(var10, var5, var7, false, var1, var12, var4);
               this.setItemValue(var1, "examprice", var13[0]);
               this.setItemValue(var1, "examprofit", var13[1]);
            } else if ("discount".equals(var2) && !"".equals(var3)) {
               var5 = this.getItemValue(var1, "oldunitprice");
               var6 = DecimalHelper.multi(var3, var5, 10);
               this.setItemValue(var1, "unitprice", var6);
               this.on_itemvaluechange(var1, "unitprice", var6);
            } else if ("goodsuseqty".equals(var2) && "".equals(var3)) {
               this.setItemValue(var1, "goodsqty", "");
               this.setItemValue(var1, "total_line", "");
               this.setItemValue(var1, "notaxmoney", "");
            }
         }
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   private boolean a(String var1) {
      ClientRequest var2 = new ClientRequest();
      StringCommand var3 = new StringCommand("销售订单管理.检查没有是否有零售价");
      ParamCommand var4;
      (var4 = new ParamCommand()).addParam("goodsid", var1);
      var4.addParam("entryid", ((Bms_sales_mde)this.mdemodel).getEntryid());
      var2.addCommand(var3);
      var2.addCommand(var4);
      ServerResponse var6 = null;
      boolean var7 = true;

      try {
         var6 = SendHelper.sendRequest(var2);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      if (((StringCommand)var6.commandAt(0)).getString().startsWith("+OK") && (var1 = ((StringCommand)var6.commandAt(1)).getString()) != null) {
         if (var1.equals("0")) {
            var7 = false;
         } else if (var1.equals("1")) {
            var7 = true;
         }
      }

      return var7;
   }

   public static String[] getLotGross(String var0, String var1, String var2, String var3, String var4) {
      RemotesqlHelper var5 = new RemotesqlHelper();
      String var6 = null;
      var6 = null;
      var6 = null;
      String var7 = null;
      String[] var8 = new String[3];
      if (var1 != null && var1.length() > 0) {
         var6 = "select nvl(unitprice,0) unitprice from bms_batch_def where goodsid=" + var0 + " and batchid=" + var1;

         try {
            var6 = var5.doSelect(var6, 0, 1).getItemValue(0, "unitprice");
            var8[2] = var6;
            var7 = DecimalHelper.multi(DecimalHelper.sub(var2, var6, 6), var3, 2);
         } catch (Exception var9) {
            var9.printStackTrace();
         }
      }

      var8[0] = var7;
      if (var7 == null || var7.equals("")) {
         var7 = "0";
      }

      if (var4 != null && !"".equals(var4)) {
         var0 = DecimalHelper.divide(var7, var4, 6);
         var8[1] = var0;
      } else {
         var8[1] = "0";
      }

      return var8;
   }

   private void a(int var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange");
      String var3 = this.getItemValue(var1, "unitprice");
      String var4 = this.getItemValue(var1, "goodsqty");
      String var5 = this.getItemValue(var1, "taxrate");
      if (!var2.equals("") && !var2.equals("0") && !var2.equals("0.0000")) {
         var3 = DecimalHelper.multi(var3, var2, 10);
      }

      var3 = DecimalHelper.divide(var2 = DecimalHelper.multi(var3, var4, 2), DecimalHelper.add("1", var5, 2), 2);
      this.setItemValue(var1, "total_line", var2);
      this.setItemValue(var1, "notaxmoney", var3);
   }

   private boolean b(int var1) {
      boolean var2 = false;
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      String var4 = this.getItemValue(var1, "goodsid");
      String var5 = this.getItemValue(var1, "batchid");
      if (var3 != null && !var3.equals("")) {
         ClientRequest var6 = new ClientRequest();
         StringCommand var7 = new StringCommand("禁销限销判断");
         ParamCommand var8;
         (var8 = new ParamCommand()).addParam("customid", var3);
         var8.addParam("goodsid", var4);
         var8.addParam("batchid", var5);
         var6.addCommand(var7);
         var6.addCommand(var8);
         ServerResponse var10 = null;

         try {
            var10 = SendHelper.sendRequest(var6);
         } catch (Exception var9) {
            var9.printStackTrace();
         }

         StringCommand var11 = (StringCommand)var10.commandAt(0);
         var5 = null;
         if (var11.getString().startsWith("+OK")) {
            var5 = ((StringCommand)var10.commandAt(1)).getString();
            if ("true".equals(var5)) {
               var2 = true;
            } else {
               var2 = false;
            }
         }

         if (!var2) {
            this.infoMessage("提示", "此货品禁止对本客户销售,请重新选择");
            this.setItemValue(var1, "opcode", "");
         }

         return var2;
      } else {
         this.infoMessage("提示", "请先录入客户");
         this.setItemValue(var1, "opcode", "");
         return false;
      }
   }

   public boolean isLimitCustom(int var1) {
      String var2 = ((Bms_sales_mde)this.mdemodel).getApvalue("非严格控制批次禁销限销");
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      if (!var2.equals("1")) {
         if (this.b != null && !"".equals(this.b) && !this.b.equals(var3)) {
            this.infoMessage("提示", "该批次不能销售(批次限销),请重新选择");
            this.setItemValue(var1, "opcode", "");
            return false;
         }

         if (this.d != null && var3.equals(this.d)) {
            this.infoMessage("提示", "该批次不能销售(批次禁销),请重新选择");
            this.setItemValue(var1, "opcode", "");
            return false;
         }
      } else if (this.b != null && !"".equals(this.b)) {
         if (!this.b.equals(var3)) {
            if (JOptionPane.showConfirmDialog(this.frame, "该批次为限销批次(不建议销售给该客户)，是否继续?", "提示", 0) == 0) {
               return true;
            }

            this.setItemValue(var1, "opcode", "");
            return false;
         }

         if (this.d.equals(var3)) {
            if (JOptionPane.showConfirmDialog(this.frame, "该批次对此客户为批次禁销(不建议销售给该客户)，是否继续?", "提示", 0) == 0) {
               return true;
            }

            this.setItemValue(var1, "opcode", "");
            return false;
         }
      }

      return true;
   }

   public boolean isLimitCustomSet(int var1, String var2) {
      String var3 = ((Bms_sales_mde)this.mdemodel).getApvalue("非严格控制批次禁销限销");
      String var4 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
      RemotesqlHelper var7;
      DBTableModel var8;
      if (!var3.equals("1")) {
         var7 = new RemotesqlHelper();
         var2 = "select * from pub_custom_set_dtl where setid=" + var2 + " and customid=" + var4;
         var8 = null;

         try {
            var8 = var7.doSelect(var2, 0, 1);
         } catch (Exception var6) {
            var6.printStackTrace();
         }

         if (var8.getRowCount() == 0) {
            this.infoMessage("提示", "该批次不能销售(批次禁销|限销),请重新选择");
            this.setItemValue(var1, "opcode", "");
            return false;
         }
      } else {
         var7 = new RemotesqlHelper();
         var2 = "select * from pub_custom_set_dtl where setid=" + var2 + " and customid=" + var4;
         var8 = null;

         try {
            var8 = var7.doSelect(var2, 0, 1);
         } catch (Exception var5) {
            var5.printStackTrace();
         }

         if (var8.getRowCount() == 0) {
            if (JOptionPane.showConfirmDialog(this.frame, "该批次为禁销|限销批次(不建议销售给该客户)，是否继续?", "提示", 0) == 0) {
               return true;
            }

            this.setItemValue(var1, "opcode", "");
            return false;
         }
      }

      return true;
   }

   private boolean c(int var1) {
      String var7 = this.getItemValue(var1, "priceid");
      String var2;
      if ((var2 = (String)this.f.get(var7)) == null) {
         DBTableModel var3 = null;
         String var4 = " select modifyflag  from pub_price_type where priceid = " + var7;
         RemotesqlHelper var5 = new RemotesqlHelper();

         try {
            var3 = var5.doSelect(var4, 0, 1);
         } catch (Exception var6) {
            this.a.error("error", var6);
            this.errorMessage("错误", var6.getMessage());
         }

         if (var3 != null && var3.getRowCount() > 0) {
            var2 = var3.getItemValue(0, "modifyflag");
            this.f.put(var7, var2);
         }
      }

      boolean var8;
      if ("1".equals(var2)) {
         var8 = true;
      } else {
         var8 = false;
      }

      return var8;
   }

   public boolean canInvokehov(String var1) {
      if (var1.equals("priceopcode")) {
         var1 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var2 = this.getItemValue(this.getRow(), "goodsid");
         if (var1 == null || var1.equals("")) {
            this.infoMessage("提示", "请先录入客户！");
            return false;
         }

         if (var2 == null || var2.equals("")) {
            this.infoMessage("提示", "请先录入货品！");
            return false;
         }
      }

      return true;
   }

   public String getHovOtherWheres(int var1, String var2) {
      if (!"goodsid".equals(var2)) {
         String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var4 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
         String var5 = this.getItemValue(var1, "goodsid");
         if (var2.equals("priceopcode")) {
            return "(customid is null or customid = " + var3 + ") and (goodsid is null or goodsid = " + var5 + ") and priceid IN(SELECT priceid FROM pub_price_type WHERE workflag IN(1) or (workflag = 3 and wholeresaleflag = 9))" + " and (entryid is null or entryid = " + var4 + ")";
         }
      }

      return super.getHovOtherWheres(var1, var2);
   }

   public void doNew() {
      if (this.on_beforeNew() == 0) {
         super.doNew();
         int var1 = this.getRow();
         this.invokeMultimdehov(var1, "opcode", "");
         this.setFocus("unitprice");
      }

   }

   protected void invokeMultimdehov(int var1, String var2, String var3) {
      if (var2.equalsIgnoreCase("opcode")) {
         String var9 = ((Bms_sales_mde)this.mdemodel).getEntryid();
         this.g.clearCond();
         var2 = ((Bms_sales_mde)this.mdemodel).getApvalue("是否提示选择老批次");
         if ("1".equals(var2)) {
            this.g.warnOldbatch(true);
         }

         boolean var10 = false;
         boolean var11 = false;
         String var4 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var5 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到批号");
         String var6 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到批次");
         String var7 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到货位");
         String var8 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存选择到货品状态");
         "1".equals(var5);
         "1".equals(var6);
         if ("1".equals(var7)) {
            var10 = true;
         }

         if ("1".equals(var8)) {
            var11 = true;
         }

         boolean var12 = ((Bms_sales_mde)this.mdemodel).getApvalue("库存是否选择到批号、批次、货位由销售控制").equals("1");
         this.g.setGoodsdtlflag(true);
         this.g.setLotflag(true);
         this.g.setBatchflag(true);
         this.g.setPosflag(var10);
         this.g.setFlagEditable(var12);
         this.g.setUsestatusflag(var11);
         this.g.setCustomid(var4);
         this.g.setEntryid(var9);
         this.g.setHovcallback(this);
         var9 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "stsetid");
         var2 = " exists (select storageid from bms_st_def where  bms_st_def.storageid=bms_stqty_union_v.storageid ) and accflag <> 5 and bms_stqty_union_v.entryid =" + ((Bms_sales_mde)this.mdemodel).getApvalue("授权独立单元");
         if (!"".equals(var9)) {
            var2 = " exists (select storageid from bms_st_set_dtl where stsetid = " + var9 + " and bms_st_set_dtl.storageid=bms_stqty_union_v.storageid ) and accflag <> 5 and bms_stqty_union_v.entryid =" + ((Bms_sales_mde)this.mdemodel).getApvalue("授权独立单元");
         }

         this.g.showDialog(this.getParentFrame(), "选择货品输入数量", "settletypeid", "", var2);
         this.setFocus("goodsuseqty");
      }

   }

   public int hovcallback_itemvaluechanged(int var1, String var2, String var3, DBTableModel var4) {
      if (!var2.equalsIgnoreCase("editgoodsqty") && !var2.equalsIgnoreCase("editpackqty")) {
         return 0;
      } else if (var4.getItemValue(var1, "editgoodsqty").length() == 0) {
         return 0;
      } else {
         int var5 = this.getRow();
         this.setItemValue(var5, "goodsid", var4.getItemValue(var1, "goodsid"));
         this.setItemValue(var5, "opcode", var4.getItemValue(var1, "opcode"));
         this.setItemValue(var5, "goodsno", var4.getItemValue(var1, "goodsno"));
         this.setItemValue(var5, "goodsname", var4.getItemValue(var1, "goodsname"));
         this.setItemValue(var5, "currencyname", var4.getItemValue(var1, "currencyname"));
         this.setItemValue(var5, "goodstype", var4.getItemValue(var1, "goodstype"));
         this.setItemValue(var5, "goodsunit", var4.getItemValue(var1, "goodsunit"));
         this.setItemValue(var5, "prodara", var4.getItemValue(var1, "prodara"));
         this.setItemValue(var5, "factoryname", var4.getItemValue(var1, "factoryname"));
         this.setItemValue(var5, "factoryid", var4.getItemValue(var1, "factoryid"));
         this.setItemValue(var5, "goodsdtlid", var4.getItemValue(var1, "goodsdtlid"));
         this.setItemValue(var5, "packname", var4.getItemValue(var1, "packname"));
         this.setItemValue(var5, "packsize", var4.getItemValue(var1, "packsize"));
         this.setItemValue(var5, "goodsqty", var4.getItemValue(var1, "editgoodsqty"));
         this.setItemValue(var5, "goodsuseqty", var4.getItemValue(var1, "editgoodsqty"));
         this.setItemValue(var5, "batchno", var4.getItemValue(var1, "batchno"));
         this.setItemValue(var5, "batchid", var4.getItemValue(var1, "batchid"));
         this.setItemValue(var5, "lotno", var4.getItemValue(var1, "lotno"));
         this.setItemValue(var5, "invaliddate", var4.getItemValue(var1, "invaliddate"));
         this.setItemValue(var5, "lotid", var4.getItemValue(var1, "lotid"));
         this.setItemValue(var5, "posno", var4.getItemValue(var1, "posno"));
         this.setItemValue(var5, "posid", var4.getItemValue(var1, "posid"));
         this.setItemValue(var5, "goodsstatus", var4.getItemValue(var1, "goodsstatus"));
         this.setItemValue(var5, "goodsstatusid", var4.getItemValue(var1, "goodsstatusid"));
         this.setItemValue(var5, "storageid", var4.getItemValue(var1, "storageid"));
         this.setItemValue(var5, "storagename", var4.getItemValue(var1, "storagename"));
         this.setItemValue(var5, "storageno", var4.getItemValue(var1, "storageno"));
         this.setItemValue(var5, "storageopcode", var4.getItemValue(var1, "storageopcode"));
         this.setItemValue(var5, "wholesaleprice", var4.getItemValue(var1, "wholesaleprice"));
         this.setItemValue(var5, "resaleprice", var4.getItemValue(var1, "resaleprice"));
         this.setItemValue(var5, "prodarea", var4.getItemValue(var1, "prodarea"));
         this.setItemValue(var5, "leastsaleqty", var4.getItemValue(var1, "leastsaleqty"));
         this.setItemValue(var5, "taxbatchprice", var4.getItemValue(var1, "unitprice"));
         this.b = var4.getItemValue(var1, "limitid");
         this.c = var4.getItemValue(var1, "limitcustomsetid");
         this.d = var4.getItemValue(var1, "bannedCustomerID");
         this.e = var4.getItemValue(var1, "bannedCustomerSetID");
         this.on_itemvaluechange(var5, "goodsid", var4.getItemValue(var1, "goodsid"));
         this.tableChanged(var5);
         return 1;
      }
   }

   public void hovcallback_ok(int var1, DBTableModel var2, CTable var3) {
   }

   public void hovcallback_cancel() {
   }

   public boolean hovcallback_checkresult(int var1, DBTableModel var2, CTable var3) {
      return true;
   }

   protected int on_new(int var1) {
      String var2 = ((Bms_sales_mde)this.mdemodel).getEntryid();
      this.setItemValue(var1, "allowbackflag", "1");
      this.setItemValue(var1, "correctflag", "0");
      this.setItemValue(var1, "reqprintquflag", "0");
      this.setItemValue(var1, "settleflag", "0");
      int var3 = this.mdemodel.getMasterModel().getRow();
      String var10 = this.mdemodel.getMasterModel().getItemValue(var3, "customid");
      String var4 = (String)this.h.get(var10);
      RemotesqlHelper var5 = null;
      String var6 = null;
      String var7 = null;
      if (var4 == null) {
         DBTableModel var11 = null;
         var2 = "select v.priceid,v.priceopcode,v.pricename from pub_company_to_definfo_v v where v.companyid=" + var10 + " and (v.entryid is null or v.entryid=" + var2 + ") order by nvl(v.entryid,-1) desc";
         var5 = new RemotesqlHelper();

         try {
            var11 = var5.doSelect(var2, 0, 1);
         } catch (Exception var8) {
            this.a.error("error", var8);
            this.errorMessage("错误", var8.getMessage());
         }

         if (var11 != null && var11.getRowCount() > 0) {
            String var13 = var11.getItemValue(0, "defaultpriceid");
            var6 = var11.getItemValue(0, "priceopcode");
            var7 = var11.getItemValue(0, "pricename");
            this.h.put(var10, "1");
            this.setItemValue(var1, "priceid", var13);
            this.setItemValue(var1, "priceopcode", var6);
            this.setItemValue(var1, "pricename", var7);
            ArrayList var9;
            (var9 = new ArrayList()).add(var13);
            var9.add(var6);
            var9.add(var7);
            this.i.put(var10, var9);
         }
      } else {
         ArrayList var12 = (ArrayList)this.i.get(var10);
         this.setItemValue(var1, "priceid", (String)var12.get(0));
         this.setItemValue(var1, "priceopcode", (String)var12.get(1));
         this.setItemValue(var1, "pricename", (String)var12.get(2));
      }

      return super.on_new(var1);
   }

   protected int on_beforemodify(int var1) {
      if (this.getItemValue(var1, "correctflag").equals("0")) {
         return -1;
      } else {
         this.setFocus("opcode");
         return super.on_beforemodify(var1);
      }
   }

   protected int on_beforedel(int var1) {
      return !this.getItemValue(var1, "correctflag").equals("0") ? -1 : super.on_beforedel(var1);
   }

   public void on_doubleclick(int var1, int var2) {
      this.setFocus("opcode");
      super.on_doubleclick(var1, var2);
   }

   protected String getEditablecolumns(int var1) {
      int var2 = this.mdemodel.getMasterModel().getRow();
      String var3 = this.mdemodel.getMasterModel().getItemValue(var2, "usestatus");
      String var5 = this.mdemodel.getMasterModel().getItemValue(var2, "approveflag");
      String var4 = this.getItemValue(var1, "priceid");
      if ("2".equals(var3) && "0".equals(var5) && !"".equals(var4) && var1 >= 0 && var1 < this.getRowCount()) {
         var5 = this.getItemValue(var1, "wholesaleflag");
         if (this.c(var1)) {
            return "9".equals(var5) ? "opcode,goodsuseunit,goodsuseqty,priceopcode,unitprice,discount,allowbackflag,dtlmemo,reqprintquflag,addrate" : "opcode,goodsuseunit,goodsuseqty,priceopcode,unitprice,discount,allowbackflag,dtlmemo,reqprintquflag";
         } else {
            return "9".equals(var5) ? "opcode,goodsuseunit,goodsuseqty,priceopcode,allowbackflag,dtlmemo,reqprintquflag,addrate" : "opcode,goodsuseunit,goodsuseqty,priceopcode,allowbackflag,dtlmemo,reqprintquflag";
         }
      } else {
         return super.getEditablecolumns(var1);
      }
   }

   public int on_beforesave() {
      int var1;
      if ((var1 = this.getRow()) != -1) {
         String var2 = this.getItemValue(var1, "unitprice");
         String var3 = this.getItemValue(var1, "taxbatchprice");
         if (DecimalHelper.toDec(var2).compareTo(DecimalHelper.toDec(var3)) < 0 && JOptionPane.showConfirmDialog(this.frame, "单价小于含税批次价，是否继续?", "提示", 0) != 0) {
            return -1;
         }

         var2 = this.getItemValue(var1, "invaliddate");
         String var6 = "";
         DBTableModel var7 = null;
         var2 = "select to_date('" + var2 + "','yyyy-mm-dd hh24:mi:ss')-sysdate as days  from dual";
         RemotesqlHelper var4 = new RemotesqlHelper();

         try {
            var7 = var4.doSelect(var2, 0, 1);
         } catch (Exception var5) {
            this.a.error("error", var5);
            this.errorMessage("错误", var5.getMessage());
         }

         if (var7 != null && var7.getRowCount() > 0) {
            var6 = var7.getItemValue(0, "days");
         }

         if (DecimalHelper.toDec(var6).compareTo(new BigDecimal("180")) < 0 && JOptionPane.showConfirmDialog(this.frame, "货品近效期小于6个月，是否继续?", "提示", 0) != 0) {
            return -1;
         }
      }

      return super.on_beforesave();
   }

   private static String b(String var0) {
      var0 = "select goodsqty from bms_sa_dtl where salesdtlid=" + var0;
      RemotesqlHelper var1 = new RemotesqlHelper();

      try {
         DBTableModel var3;
         if ((var3 = var1.doSelect(var0, 0, 1)) != null && var3.getRowCount() > 0) {
            return var3.getItemValue(0, "goodsqty");
         }
      } catch (Exception var2) {
         var2.printStackTrace();
      }

      return "0";
   }
}
